diff -ur libedit-20140213-3.1.orig/src/chartype.h libedit-20140213-3.1/src/chartype.h
--- libedit-20140213-3.1.orig/src/chartype.h	2012-03-11 09:54:58.000000000 +0000
+++ libedit-20140213-3.1/src/chartype.h	2014-06-17 14:50:46.938275000 +0000
@@ -44,7 +44,7 @@
  * supports non-BMP code points without requiring UTF-16, but nothing
  * seems to actually advertise this properly, despite Unicode 3.1 having
  * been around since 2001... */
-#if !defined(__NetBSD__) && !defined(__sun) && !(defined(__APPLE__) && defined(__MACH__))
+#if !defined(__NetBSD__) && !defined(__sun) && !(defined(__APPLE__) && defined(__MACH__)) && !defined(__FreeBSD__) && !defined(__DragonFly__)
 #ifndef __STDC_ISO_10646__
 /* In many places it is assumed that the first 127 code points are ASCII
  * compatible, so ensure wchar_t indeed does ISO 10646 and not some other
diff -ur libedit-20140213-3.1.orig/src/vi.c libedit-20140213-3.1/src/vi.c
--- libedit-20140213-3.1.orig/src/vi.c	2013-07-12 14:13:34.000000000 +0000
+++ libedit-20140213-3.1/src/vi.c	2014-06-17 14:50:21.618262000 +0000
@@ -918,15 +918,15 @@
  * NB: posix implies that we should enter insert mode, however
  * this is against historical precedent...
  */
-#ifdef __weak_reference
+#ifdef __weak_extern
 __weakref_visible char *my_get_alias_text(const char *)
-    __weak_reference(get_alias_text);
+    __weak_extern(get_alias_text);
 #endif
 protected el_action_t
 /*ARGSUSED*/
 vi_alias(EditLine *el __attribute__((__unused__)), Int c __attribute__((__unused__)))
 {
-#ifdef __weak_reference
+#ifdef __weak_extern
 	char alias_name[3];
 	char *alias_text;
 
